//
// Unicode.cpp
//
// $Id: //poco/1.3/Foundation/src/Unicode.cpp#2 $
//
// Library: Foundation
// Package: Text
// Module:  Unicode
//
// Copyright (c) 2007, Applied Informatics Software Engineering GmbH.
// and Contributors.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//


#include "Poco/Unicode.h"


#include <wctype.h>
#include <locale.h>


namespace Poco {


//void Unicode::properties(int ch, CharacterProperties& props)
//{
//}


locale_t get_ctype_locale() {
	static locale_t locale= NULL;
	if(!locale)
		locale= newlocale(LC_CTYPE_MASK, "en_US.UTF-8", NULL);
	return locale;
}

	
bool Unicode::isLower(int ch)
{
	return iswlower_l(ch, get_ctype_locale());
}

	
bool Unicode::isUpper(int ch)
{
	return iswupper_l(ch, get_ctype_locale());
}

	
int Unicode::toLower(int ch)
{
	return towlower_l(ch, get_ctype_locale());
}


int Unicode::toUpper(int ch)
{
	return towupper_l(ch, get_ctype_locale());
}


} // namespace Poco
